/****************************************************************************
*
* (C) 2000-2003 by BECK IPC GmbH and PWR Solutions GbR
*
*  BECK IPC GmbH                    PWR Solutions GbR
*  Garbenheimerstr. 36-38           Euckenstrasse 17
*  D-35578 Wetzlar                  D-81369 Mnchen
*
*  Phone : (49)-6441-905-0
*  Fax   : (49)-6441-905-245
*
* ---------------------------------------------------------------------------
* Module        : I2C_API.H
* Function      : Defines and typedefs for I2C_API.C
* ---------------------------------------------------------------------------
* History       :
*  Vx.yy                   Author  Changes
*  V1.00      17.07.00     roth    Create
* ---------------------------------------------------------------------------
*  Published on the BECK WebSite with kind permission of Bernhard Roth.

$Header: I2C_API.H, 5, 06.02.2004 13:52:27, Andre Pribil$

****************************************************************************/

#ifndef __I2CAPI_H__
#define __I2CAPI_H__


/*************************************************************************/
//prototypes
/*************************************************************************/
#ifdef __cplusplus
extern "C" {
#endif

void _cdecl I2C_init             (void);
void _cdecl I2C_release          (void);
void _cdecl I2C_restart          (void);
unsigned char _cdecl I2C_scan    (unsigned char start_addr, unsigned char end_addr);
int  _cdecl I2C_transmit_block   (unsigned char slave,
                                  const char far * buffer,
                                  int length);
int  _cdecl I2C_receive_block    (unsigned char slave, char far * buffer, int length);
int  _cdecl I2C_transmit_char    (unsigned char slave, char char_out);
int  _cdecl I2C_receive_char     (unsigned char slave,
                                  char * char_in,
                                  unsigned char not_last);
void _cdecl I2C_select_clock_pin (unsigned char pio_no);
void _cdecl I2C_select_data_pin  (unsigned char pio_no);

#ifdef __cplusplus
}
#endif

/*************************************************************************/
#endif /* __I2CAPI_H__*/
/*************************************************************************/
//end i2c_api.h
/*************************************************************************/