/******************************************************************************
*
* (c) 2004 by BECK IPC GmbH
*
* BECK IPC GmbH
* Garbenheimerstr. 36-38
* D-35578 Wetzlar
*
* Phone: (49)-6441-905-0
* Fax:   (49)-6441-905-245
*
*******************************************************************************
*
* Disclaimer: This program is an example and should be used as such.
*             If you wish to use this program or parts of it in your application,
*             you must validate the code yourself. BECK IPC GmbH can not be held
*             responsible for the correct functioning or coding of this example.
*
* Module:     address.c
* Function:   Example for using the hardware API. This shows how to enable the
*             address pins A0..A2.
*             This example provides the same functionality as the internal
*             "adr" RTOS command.
*
*******************************************************************************
*
* $Header: address.c, 2, 31.03.2004 11:15:31, Andre Pribil$
*
******************************************************************************/

/******************************************************************************
* Includes
******************************************************************************/
#include <stdio.h>
#include <stdlib.h>
#include "clib.h"


/******************************************************************************
* Display command line options
******************************************************************************/
void usage (void)
{
  printf("\nProgram enables address lines");
  printf("\nUsage: address <addr-no> ,  addr-no=0, 1, 2");
}

/******************************************************************************
* Main
******************************************************************************/
void main (int argc, char *argv[])
{
  unsigned adr;

  if (argc==2)
  {
     adr = atoi(argv[1]);
     if (adr>2)
     {
       usage();
       return;
     }
  }
  else
  {
     usage();
     return;
  }

  printf("\nEnable A%d", adr);

  // Enable address lines
  pfe_enable_adr(adr);

  printf("\nPlease use \"ib\" and \"ob\" commands to test");
}
