/******************************************************************************
*
* (c) 2004 by BECK IPC GmbH
*
* BECK IPC GmbH
* Garbenheimerstr. 36-38
* D-35578 Wetzlar
*
* Phone: (49)-6441-905-0
* Fax:   (49)-6441-905-245
*
*******************************************************************************
*
* Disclaimer: This program is an example and should be used as such.
*             If you wish to use this program or parts of it in your application,
*             you must validate the code yourself. BECK IPC GmbH can not be held
*             responsible for the correct functioning or coding of this example.
*
* Module:     apiping.c
* Function:   This program demonstrates the usage of the TCP/IP-API of the IPC@Chip.
*             It's a simple ping client.
*
*******************************************************************************
*
* $Header: apiping.c, 5, 31.03.2004 11:15:31, Andre Pribil$
*
******************************************************************************/

/******************************************************************************
* Includes
******************************************************************************/
#include <stdio.h>
#include <stdlib.h>
#include <conio.h>
#include <clib.h>


/******************************************************************************
* main()
******************************************************************************/
void main( int paramcnt, char *param[] )
{
   Ping ping;
   unsigned long tr = 0L;
   unsigned long rc = 0L;
   unsigned long timeout=0L;
   int error;
   int retval;
   int key=0;

   // Set Standard IO Focus
   BIOS_Set_Focus( FOCUS_APPLICATION );
   printf("\r\nPing API example for SC12");


   // Check for arguments remote IP and max send count
   if (paramcnt!=3)
   {
      printf("\r\nInvalid parameters\r\nUsage APIPING [remote IP] [pingCount(0 pings forever)]");
      BIOS_Set_Focus( FOCUS_BOTH );
      exit(0);
   }


   // Init Ping struct
   ping.sd=-1;
   ping.transmitted  =
   ping.received     =
   ping.lastsenderr  =
   ping.lastrcverr   = 0L;
   ping.pingstate    = 0;
   ping.remoteHostNamePtr = param[1]; // remote IP
   ping.pingInterval      = 2;        //ping with two second interval
   ping.count             = strtol(param[2],NULL,10); //max count of send
   ping.pingDataLength    = 32;

   // Open ping
   retval = Ping_Open( &ping, &error );
   if (retval==-1)
   {
      printf("\r\nError open Ping API %d",error);
      goto End_Execution;
   }

   if(ping.count==0L)
   {
      //ping forever until user key break
      printf("\r\nPinging %s with 32 bytes of data, ESC exits\r\n",param[1]);
   }
   else
   {
     //ping with a limited number or until user break
     printf("\r\nPinging %s with 32 bytes of data , sending %ld packets, ESC exits\r\n",
           param[1],ping.count);
   }


   //Reading cylic the ping statistics
   while(1)
   {
     api_sleep(30);

     if(kbhit())key=getch();
     if(key==27)
     {
        printf("\r\nUser break\r\n");
        goto End_Execution;
     }

     timeout+=30L;

     // get ping status
     retval = Ping_Statistics(&ping);
     if (retval==-1)
     {
         printf("\r\nCan't get statistics, ping socket is closed");
         goto End_Execution;
     }

     if(ping.transmitted > tr)
     {
        tr = ping.transmitted;
        if(ping.received > rc)
        {
          rc=ping.received;
          printf("\r\nReply from %s time %ld ms",param[1],ping.lastRtt);
          timeout=0L;
        }
     }
     if(timeout>=3*ping.pingInterval*1000)
     {
        printf("\r\nPing has timed out, exit");
        break;
     }

     if(ping.count!=0L)
     {
        if(ping.transmitted>ping.count) break;
     }
  }


  End_Execution:


  //Report the final results
  printf("\r\n\r\nPackets send %ld  replies %ld\r\n"
          ,ping.transmitted,ping.received);

  //Close Ping socket
  Ping_Close(ping.sd);

  printf("\r\nProgram exit\r\n");

  // reset STDIO Focus
  BIOS_Set_Focus( FOCUS_BOTH );
}



// End of file
